%define current_version 1.0.64

Name:		vzdeploy8
Version:	%{current_version}
Release:    1%{?dist}
Summary:	Upgrades CentOS or RHEL 8 distros to Virtuozzo Linux 8 or convert to Almalinux8

Group:		Tools
License:	Virtuozzo
URL:		https://virtuozzo.com
Source0:	%{name}-%{version}.tar.bz2

Requires:	bash
Requires:	vztt >= 7.1.5
BuildArch: noarch

%define debug_package %{nil}

%description
vzdeploy8 removes yum repo configuration related to CentOS/RHEL,
as well as release related packages. Installs Virtuozzo Linux or AlmaLinux
release related packages and new kernel (unless SKIP_KERNEL is set)

%prep
%setup -q


%build

%install
mkdir -p %{buildroot}/%{_bindir}
install -m 0755 vzconvert8 %{buildroot}/%{_bindir}/vzconvert8
install -m 0755 vzdeploy8 %{buildroot}/%{_bindir}/%{name}
install -m 0755 vzdeploy %{buildroot}/%{_bindir}/vzdeploy7
install -m 0755 vzdeploy8_ct %{buildroot}/%{_bindir}/%{name}_ct
install -m 0755 vzdeploy7_ct %{buildroot}/%{_bindir}/vzdeploy7_ct
install -m 0755 almaconvert8 %{buildroot}/%{_bindir}/almaconvert8
install -m 0755 almadeploy8_ct %{buildroot}/%{_bindir}/almadeploy8_ct
# mkdir -p %{buildroot}/vz/template/almaconvert-elevate
# install -m 0644 repo/*.rpm %{buildroot}/vz/template/almaconvert-elevate/
# mkdir -p %{buildroot}/vz/template/almaconvert-elevate/repodata/
# install -m 0644 repo/repodata/* %{buildroot}/vz/template/almaconvert-elevate/repodata/

%files
%{_bindir}/%{name}
%{_bindir}/%{name}_ct
%{_bindir}/vzdeploy7
%{_bindir}/vzdeploy7_ct
%{_bindir}/vzconvert8
%{_bindir}/almaconvert8
%{_bindir}/almadeploy8_ct
# /vz/template/almaconvert-elevate/*
# /vz/template/almaconvert-elevate/repodata/*

%changelog
* Wed Jan 25 2024 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.64-1
 - Fix snapshot race condition
 - Move package to OpenVZ repo
 
* Mon Jan 22 2024 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.63-2
 - Make snapshot after blocker checks. 
 - Add description to snapshot. 
 - Add --non-interactive key to --start elevate-cpanel call. 
 - Stop container before snapshoting. PSBM-152772

* Tue Jan 09 2024 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.63-1
 - Check vz partition have enough space vefore upgrade PSBM-153203
 - Run --check --noleapp prior the update PSBM-153220
 - Switch to the elevate_continue key for continuing failed elevate script PSBM-153221
 - Update the error handling. PSB-153001

* Thu Nov 30 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.61-6
 - Fix bugs with elevate process
 - Keep passwd file intact for usage after upgrade
 
* Sat Nov 25 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.61-1
 - Massive migration of CPanel upgrade to repoless process.
 - Native checks implemented.
 - Fixed issue with extrapackages.
 - Adopted for legacy container templates.
 

* Wed Oct 11 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.59-2
 - Move migration to local repo for cpanel packages
 - Add vztt version specific as requirement

* Wed Oct 11 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.58-5
 - Move thee sshd polishing to almadeploy8_Ct and enhance space limit warning to 5Gb

* Tue Oct 10 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.58-4
 - Fix non reverting dry-run. The vzpkg was failing due to obsolete almalinux 8.5 repo. PSBM-151320
 - Fix ssh files permissions after conversion PSBM-151262.

* Sun Oct 08 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.58-2
 - Fix the upgrade process with non-standard RPMs installed CPanel/Plesk for instance.

* Tue Sep 19 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.57-2
 - Minor fixes for cosmetics(including wrong template detection)

* Mon Sep 18 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.57-1
 - Fix loop waiting for file

* Wed Sep 13 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.56-1
 - Apply cosmetic changes as per PSBM-150636
 - Fix missspelling PSBM-150636
 - Add Dry run message for certain key PSBM-150636
 - Add the other templates to listing PSBM-150651
 - Fix piping for alaconvert8

* Thu Sep 07 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.55-3
 - Add triggers for elevate script. PSBM-150495

* Thu Sep 07 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.55-1
 - Fix improper container listing on list command. PSBM-150365
 - Fix improper output in case the network is not configured in container.PSBM-150401	
 - Put elevate metavar and key.Placeholders for elevate process. PSBM-149955
 
* Fri Aug 04 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.54
 - Correct list of OSes possible to upgrade.

* Fri Aug 04 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.53
 - Update the release packages checks
 
* Fri Aug 04 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.52
 - Fix release package removal.

* Fri Aug 04 2023 Artem Vasiliev <artem.vasiliev@virtuozzo.com> 1.0.51
 - Implement CT conversion to Almalinux(PSBM-148920), fix repos and releases within containers.

* Fri Feb 18 2022 Updates Tracker <dsilakov@virtuozzo.com> 1.0.50
 - Fix dry-run for almalinux-8 and support rocky in vzdeploy8_ct (Denis Silakov
<dsilakov@virtuozzo.com>)

* Fri Feb 11 2022 Updates Tracker <dsilakov@virtuozzo.com> 1.0.49
 - Now we should check version of vzlinux-8 template when checking if we are
able to convert C7 CT (Denis Silakov <dsilakov@virtuozzo.com>)

* Mon Feb 07 2022 Denis Silakov <dsilakov@virtuozzo.com> 1.0.48
 - Hide output of DA check

* Mon Feb 07 2022 Denis Silakov <dsilakov@virtuozzo.com> 1.0.47
 - Support remi repos, #1

* Mon Feb 07 2022 Denis Silakov <dsilakov@virtuozzo.com> 1.0.46
 - Rework c7 -> vzl8 upgrade path to first convert to vzl7, since c8 repos are
not available anymore
 - Add vzdeploy7_ct wrapper
 - Convert centos-8.stream to stable vzlinux-8
 - Install vzdeploy7 parts

* Tue Feb 01 2022 Denis Silakov <dsilakov@virtuozzo.com> 1.0.45
 - Fix typo in the last commit
 - Now VHS only supports centos-8.stream templates

* Thu Dec 16 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.44
 - vzctl doesn't support -n for snapshot name, only --name

* Thu Dec 02 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.43
 - Try vzctl for snapshot if prlctl failed (missing or can't understand id)

* Mon Nov 29 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.42
 - Enable explicit PermitRootLogin in ct when converting to vzlinux8
 - Use ls to check directadmin presence. 'file' can be missing

* Wed Oct 20 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.41
 - Simplify ct detection logic a bit
 - Do not fail when can't check da

* Tue Oct 19 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.40
 - Fix ctid detection

* Tue Oct 19 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.39
 - Do not fail if centos-8-x86_64-ez is not installed at all

* Mon Oct 18 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.38
 - Refuse inplae upgrade of CTs with DA inside

* Thu Sep 16 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.37
 - Check for c8 template version to decide if we support c7 conversion or not
(Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix indentation (Denis Silakov <dsilakov@virtuozzo.com>)

* Thu Sep 02 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.36
 - Restore app templates when converting CTs from c7, do not print added/removed
packages (there is a ton of them), correclty handle failed upgrades
 - Save separate timestamp for conversion from c7
 - Support centos 7 in check_repo
 - Improve help a bit

* Tue Aug 31 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.35
 - More adoptions for alma
 - Support conversion of CentOS 7 CT to VzLinux 8

* Mon Aug 16 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.34
 - More adoptions for alma (Denis Silakov <dsilakov@virtuozzo.com>)
 - Improve message about unsupported soft a bit (Denis Silakov
<dsilakov@virtuozzo.com>)

* Thu Aug 12 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.33
 - Revert "No need in files specific to vz build infrastructure"
 - Be more generic - we can convert Alma and potentially other templates
 - Create README.md (dsilakov <dsilakov@virtuozzo.com>)
 - Fix comment in vzconvert (dsilakov <dsilakov@virtuozzo.com>)
 - No need in files specific to vz build infrastructure

* Sat Apr 24 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.32
 - Increase 'ulimit -n' for ancestors (Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Apr 23 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.31
 - Fix launch without --log argument (Denis Silakov <dsilakov@virtuozzo.com>)

* Wed Apr 21 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.30
 - Add copyright, add timings, improve logging - PSBM-128673 (Denis Silakov
<dsilakov@virtuozzo.com>)

* Tue Apr 20 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.28
 - Print message about successful converison (Denis Silakov
<dsilakov@virtuozzo.com>)

* Tue Apr 20 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.27
 - Revert some spelling changes (Denis Silakov <dsilakov@virtuozzo.com>)
 - vzdeploy8_ct: be ready that container has 'centos-8' in config (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Edits to log messages and other texts (Artem Pavlenko
<apavlenko@virtuozzo.com>)
 - Do not fail on missing ct (Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix upgrade on EFI systems, VZP-1344 (Denis Silakov <dsilakov@virtuozzo.com>)

* Mon Apr 19 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.26
 - Imprive logging, PSBM-128363 (Denis Silakov <dsilakov@virtuozzo.com>)
 - Set debug to 1 by default, othewise we have too few output lines (Denis
Silakov <dsilakov@virtuozzo.com>)

* Wed Apr 14 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.24
 - Implement --parallel option and parallel container upgrade (Denis Silakov
<dsilakov@virtuozzo.com>)

* Mon Apr 12 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.23
 - Support non-standard ve_private in vzdeploy8_ct (Denis Silakov
<dsilakov@virtuozzo.com>)

* Mon Apr 12 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.22
 - For msg conversion to string in log_msg (Denis Silakov
<dsilakov@virtuozzo.com>)

* Mon Apr 12 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.21
 - Fix logfile processing (Denis Silakov <dsilakov@virtuozzo.com>)
 - Redirect vzpkg stderr to stdout (Denis Silakov <dsilakov@virtuozzo.com>)

* Mon Apr 12 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.20
 - Redirect vzpkg stderr to stdout (Denis Silakov <dsilakov@virtuozzo.com>)

* Mon Apr 12 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.19
 - Revert new way of logging, turned out to confuse some terminals (Denis
Silakov <dsilakov@virtuozzo.com>)

* Fri Apr 09 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.18
 - Drop qoutas from VE_PRIVATE if any, PSBM-128214 (Denis Silakov
<dsilakov@virtuozzo.com>)

* Fri Apr 09 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.17
 - Init vzdeploy_out before use (Denis Silakov <dsilakov@virtuozzo.com>)
 - Flush stdout a bit faster, hide some warnings, fix vztt.conf processing
(Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Apr 09 2021 VZ Auto Builder <builder@virtuozzo.com> 1.0.15
 - Wait for CT to start when converting stopped ct, PSBM-128279 (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Added stub for --parallel option (Denis Silakov <dsilakov@virtuozzo.com>)

* Thu Apr 08 2021 Denis Silakov <dsilakov@virtuozzo.com> 1.0.14
 - Handle non-standard VE_PRIVATE, VZP-1362

* Fri Mar 12 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.8
 - Add verbose/quiet modes (Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Mar 12 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.7
 - Not forget vzdeploy8.specetup (Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix source name (Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix typo (Denis Silakov <dsilakov@virtuozzo.com>)
 - Added dummy changelog (Denis Silakov <dsilakov@virtuozzo.com>)
 - Build from source git (Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Mar 12 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.6
 - Fix source name (Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix typo (Denis Silakov <dsilakov@virtuozzo.com>)
 - Added dummy changelog (Denis Silakov <dsilakov@virtuozzo.com>)
 - Build from source git (Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Mar 12 2021 Updates Tracker <dsilakov@virtuozzo.com> 1.0.5
 - Fix typo (Denis Silakov <dsilakov@virtuozzo.com>)
 - Added dummy changelog (Denis Silakov <dsilakov@virtuozzo.com>)
 - Build from source git (Denis Silakov <dsilakov@virtuozzo.com>)

